local dndBanner = "<BSW> "
local dndString = dndBanner .. "I'm busy fighting%s."
local combatEndedString = dndBanner .. "Combat ended."
local successString = " This boss is now history !"
local wipeString = " That's a wipe ! :( "

local diffRef = {[0] = "", [3] = "[10]", [4] = "[25]", [5] = "[10H]", [6] = "[25H]", [7] = "[LFR]", [14] = "[Normal]", [15] = "[Heroic]", [16] = "[Mythic]", [17] = "[LFR]"}


local frame = CreateFrame("Frame")
local addonName = ...
local pname = UnitName("player")
local whisperers = {}
local bosses = {}
local bossFormat = " %s (%d%%)"

function frame:ENCOUNTER_END(encounterID, name, difficulty, size, success)
	local strStatus = ""
	if success == 1 then
		strStatus = successString
	else
		strStatus = wipeString
		if UnitExists("boss1") then
			if #bosses == 0 then
				for i = 1, MAX_BOSS_FRAMES do
					if UnitExists("boss" .. i) then
						bosses[i] = UnitName("boss" .. i)
					end
				end
			end
			for i, bossName in next, bosses do
				local hp = math.floor(UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100 + 0.5)
				strStatus = strStatus .. bossFormat:format(bossName, hp)
			end
		end
	end
		
	for player in pairs(whisperers) do
		if type(player) == "string" then
			SendChatMessage(combatEndedString .. strStatus, "WHISPER", nil, player)
		end
		if type(player) == "number" then
			BNSendWhisper(player, combatEndedString .. strStatus)
		end
		-- print(combatEndedString .. strStatus .. "WHISPER" .. player)
	end
	wipe(whisperers)
	wipe(bosses)
end

function frame:PLAYER_REGEN_ENABLED()
	if not(UnitExists("boss1")) then
		-- We only use this if players were not already whispered after ENCOUNTER_END event AND if there is no boss left
		for player in pairs(whisperers) do
			if type(player) == "string" then
				SendChatMessage(combatEndedString, "WHISPER", nil, player)
			end
			if type(player) == "number" then
				BNSendWhisper(player, combatEndedString)
			end
			print(combatEndedString .. "WHISPER" .. player)
		end
		wipe(whisperers)
		wipe(bosses)
	end
end

function frame:CHAT_MSG_WHISPER(msg, sender, _, _, _, gm)
	if not UnitExists("boss1") then return end
	if type(sender) ~= "string" or sender == pname or UnitInRaid(sender) or gm == "GM" then return end
	if not whisperers[sender] or msg == "status" then
		whisperers[sender] = true
		if #bosses == 0 then
			for i = 1, MAX_BOSS_FRAMES do
				if UnitExists("boss" .. i) then
					bosses[i] = UnitName("boss" .. i)
				end
			end
		end
		if #bosses == 0 then return end
		local str = " "
		local bossDiff = diffRef[select(3, GetInstanceInfo())]
		if not(bossDiff) then bossDiff = "N/A" end
		str = str .. bossDiff
		for i, bossName in next, bosses do
			local hp = math.floor(UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100 + 0.5)
			str = str .. bossFormat:format(bossName, hp)
		end
		SendChatMessage(dndString:format(str), "WHISPER", nil, sender)
		-- print(dndString:format(str) .. "WHISPER" .. sender)
	end
end

function frame:CHAT_MSG_BN_WHISPER(msg, sender, _, _, _, _, _, _, _, _, _, _, pID, _)
	if not UnitExists("boss1") then return end
	if type(pID) ~= "number" or BNIsSelf(pID) then return end
	if not whisperers[pID] or msg == "status" then
		whisperers[pID] = true
		if #bosses == 0 then
			for i = 1, MAX_BOSS_FRAMES do
				if UnitExists("boss" .. i) then
					bosses[i] = UnitName("boss" .. i)
				end
			end
		end
		if #bosses == 0 then return end
		local str = " "
		local bossDiff = diffRef[select(3, GetInstanceInfo())]
		if not(bossDiff) then bossDiff = "N/A" end
		str = str .. bossDiff
		for i, bossName in next, bosses do
			local hp = math.floor(UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100 + 0.5)
			str = str .. bossFormat:format(bossName, hp)
		end
		BNSendWhisper(pID, dndString:format(str))
		-- print(pID .. dndString:format(str))
	end
end

frame:SetScript("OnEvent", function(self, event, msg, ...) self[event](self, msg, ...) end)
frame:RegisterEvent("CHAT_MSG_WHISPER")
frame:RegisterEvent("CHAT_MSG_BN_WHISPER")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("ENCOUNTER_END")
frame:RegisterEvent("ADDON_LOADED")

function frame:ADDON_LOADED(msg)
	if msg ~= addonName then return end
	self:UnregisterEvent("ADDON_LOADED")
	if not SBW_DisableChatFilter then
		local bannerTest = "^" .. dndBanner
		ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(self, event, msg)
			if msg:find(bannerTest) then return true end
		end)
	end
end
